<?php

namespace App\Models;

use App\Http\Helpers\Hasher;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;

class ContractObligation extends Model
{
    protected $table = 'contract_obligations';

    protected $appends = [
        'hash_id', 
        'contract_list', 
        'contract_obligation_dependency_list', 
        'depend_contract_obligation_dependency_list'
    ];

    protected $hidden = [
        'id', 'in_time_contract_obligation_template',
    ];

    public function contract()
    {
        return $this->belongsTo('App\Models\Contract', 'contract_id');
    }

    public function contract_obligation_dependency()
    {
        return $this->hasMany('App\Models\ContractObligationDependency', 'contract_obligation_id');
    }

    public function depend_contract_obligation_dependency()
    {
        return $this->hasMany('App\Models\ContractObligationDependency', 'depend_contract_obligation_id');
    }

    public function getHashIdAttribute()
    {
        return Hasher::encode('contract_obligations', $this->id);
    }

    public function getContractListAttribute()
    {
        return $this->contract()->get()->makeHidden(['contract_obligation_list']);
    }

    public function getContractObligationDependencyListAttribute()
    {
        return $this->contract_obligation_dependency()
        // ->where('status', config('constants.contract_obligation.status.active'))
        ->get()->makeHidden(['contract_obligation_list', 'depend_contract_obligation_list']);
    }

    public function getDependContractObligationDependencyListAttribute()
    {
        return $this->depend_contract_obligation_dependency()
            // ->where('status', config('constants.contract_obligation.status.active'))
            ->get()->makeHidden(['contract_obligation_list', 'depend_contract_obligation_list']);
    }

    public function getUpdatedAtAttribute($date) 
    {
        return $date ? Carbon::parse($date)->timezone('Asia/Kuala_Lumpur')->format('Y-m-d') : '';
    }

    public function getCreatedAtAttribute($date) 
    {
        return $date ? Carbon::parse($date)->timezone('Asia/Kuala_Lumpur')->format('Y-m-d') : '';
    }
}
